<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String title = "Flagged RNA items";
	final int numFlagged = Values.getInt(request.getParameter("numFlagged"));
	final int numSelected = Values.getInt(request.getParameter("numSelected"));
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="table.js" styles="table.css">
<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
<script>

function init()
{
	var flagged = window.opener.Rna.getFlagged();
	var frm = document.forms['flaggedRna'];
	for (var i = 0; i < flagged.length; i++)
	{
		var rna = flagged[i];
		document.getElementById('rna.'+i).innerHTML = rna.name;
		if (rna.bioWell)
		{
			var well = rna.bioWell;
			document.getElementById('location.'+i).innerHTML = well.bioPlate.name +' ['+WELL_ALPHA[well.row]+(well.column+1)+']';
		}
		document.getElementById('remainingQuantity.'+i).innerHTML = rna.remainingQuantity;
		document.getElementById('flag.'+i).innerHTML = rna.flag;
		frm['use.'+i].rna = rna;
	}
}

function useSelected()
{
	var frm = document.forms['flaggedRna'];
	var i = 0;
	while (frm['use.'+i])
	{
		if (frm['use.'+i].checked)
		{
			var rna = frm['use.'+i].rna;
			window.opener.setRnaCallback(rna.id, rna.name);
		}
		i++;
	}
	window.close();
}
</script>

</base:head>
<base:body onload="init()">
	<h1><%=title %></h1>

	<div class="content">
	<tbl:table id="flaggedRna" subclass="fulltable">
		<tbl:columndef id="rna" title="RNA" />
		<tbl:columndef id="location" title="Bioplate" />
		<tbl:columndef id="remainingQuanity" title="Remaining quantity (µg)" />
		<tbl:columndef id="flag" title="Flag" />
	
		<tbl:data style="top: 0px; margin-top: 0px;">
			<tbl:headers>
				<tbl:headerrow>
					<th></th>
					<tbl:columnheaders />
				</tbl:headerrow>
			</tbl:headers>
			<tbl:rows>
			<%
			for (int i = 0; i < numFlagged; ++i)
			{
				%>
				<tbl:row>
					<td style="text-align: center; width: 20px;"><input type="checkbox" name="use.<%=i%>" <%=numSelected == 0 ? "disabled" : "" %>></td>
					<tbl:cell column="rna" id="<%="rna."+i%>"><%=i%></tbl:cell>
					<tbl:cell column="location" id="<%="location."+i%>"></tbl:cell>
					<tbl:cell column="remainingQuanity" id="<%="remainingQuantity."+i%>"></tbl:cell>
					<tbl:cell column="flag" id="<%="flag."+i%>"></tbl:cell>
				</tbl:row>
				<%
			}
			%>
			</tbl:rows>
		</tbl:data>
	</tbl:table>
	</div>

	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button onclick="useSelected()" title="Use selected" 
			visible="<%=numSelected > 0%>" tooltip="Use the RNA and ignore the flag"
			image="<%=home + "/images/manual_rna.png"%>" />
		<base:button onclick="window.close()" title="Close" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>